<?php

/**
 *   @copyright Copyright (c) 2007 Quality Unit s.r.o.
 *   @author Maros Fric
 *   @package PostAffiliatePro
 *   @since Version 1.0.0
 *
 *   Licensed under the Quality Unit, s.r.o. Standard End User License Agreement,
 *   Version 1.0 (the "License"); you may not use this file except in compliance
 *   with the License. You may obtain a copy of the License at
 *   http://www.postaffiliatepro.com/licenses/license
 *
 */

class Pap_Definition extends Gpf_Plugins_Definition  {
    public function __construct() {
        $this->codeName = 'PapCore';
        $this->name = 'Pap Core Plugin';
        $this->description = 'Pap Core functionality.';
        $this->version = Gpf_Application::getInstance()->getVersion();
        $this->pluginType = self::PLUGIN_TYPE_SYSTEM;

        $this->initDefines();
    }

    protected function initDefines() {
        $this->addDefine('Pap_Affiliate.initJsResources', 'Gpf_Contexts_Module');
        $this->addDefine('PostAffiliate.beforeAllActions', 'Pap_Contexts_Action');
        $this->addDefine('PostAffiliate.afterAllActions', 'Pap_Contexts_Action');
        $this->addDefine('Pap_Signup_AffiliateForm.checkBeforeSaveNotApi', 'Gpf_Rpc_Form');
        $this->addDefine('HtmlSignupFormSettings.initPanel', 'Gpf_Ui_DynamicFormPanel');
        $this->addDefine('PostAffiliate.signup.after', 'Pap_Contexts_Signup');
        $this->addDefine('PostAffiliate.signup.afterFail', 'Pap_Contexts_Signup');
        $this->addDefine('PostAffiliate.affiliate.firsttimeApproved','Pap_Affiliates_User');
        $this->addDefine('PostAffiliate.affiliate.firsttimeDeclined','Pap_Affiliates_User');
        $this->addDefine('PostAffiliate.affiliate.userStatusChanged','Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.affiliate.sendNewUserSignupApprovedMail','Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.merchant.menu', 'Gpf_Menu');
        $this->addDefine('PostAffiliate.iconSet', 'Pap_Common_IconSet');
        $this->addDefine('PostAffiliate.UsersTable.constraints', 'Pap_Db_Table_Users');
        $this->addDefine('Pap_Common_User_RefidConstraint.init', 'Pap_Common_User_RefidConstraint');

        $this->addDefine('PostAffiliate.CampaignsGrid.initDataColumns', 'Gpf_View_GridService');
        $this->addDefine('PostAffiliate.CampaignsGrid.initViewColumns', 'Gpf_View_GridService');
        $this->addDefine('PostAffiliate.CampaignsGrid.initDefaultView', 'Gpf_View_GridService');
        $this->addDefine('PostAffiliate.CampaignForm.insertDefaultCommissionTypes', 'Pap_Merchants_Campaign_CampaignForm');
        $this->addDefine('PostAffiliate.CampaignForm.afterAdd', 'Pap_Common_Campaign');
        $this->addDefine('PostAffiliate.CampaignForm.afterEdit', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.CampaignForm.checkBeforeSave', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.CampaignForm.afterCopyCampaign', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.Campaign.insert', 'Pap_Db_Campaign');
        $this->addDefine('PostAffiliate.Campaign.delete', 'Pap_Db_Campaign');

        $this->addDefine('PostAffiliate.Campaign.getAffiliatesIdsForCampaign', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.CommissionTypeForm.saveSettings', 'Pap_Merchants_Campaign_CommissionTypeRpcForm');
        $this->addDefine('PostAffiliate.CommissionTypeForm.afterSaveSettings', 'Pap_Merchants_Campaign_CommissionTypeRpcForm');
        $this->addDefine('PostAffiliate.CommissionTypeForm.loadSettings', 'Pap_Merchants_Campaign_CommissionTypeRpcForm');

        $this->addDefine('PostAffiliate.CommissionTypeForm.loadAllCommissions', 'Pap_Merchants_Campaign_CommissionTypeRpcForm');
        $this->addDefine('PostAffiliate.CommissionTypeForm.saveAllCommissions', 'Pap_Merchants_Campaign_CommissionTypeRpcForm');

        $this->addDefine('Pap_Tracking_Action_ActionRecognizers', 'Pap_Tracking_Action_ActionRecognizers');
        $this->addDefine('PostAffiliate.BannerFactory.getBannerObjectFromType', 'Pap_Common_Banner_BannerRequest');
        $this->addDefine('PostAffiliate.BannerFactory.getBannerNameFromType', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.Banner.insert', 'Pap_Db_Banner');
        $this->addDefine('PostAffiliate.Banner.update', 'Pap_Db_Banner');
        $this->addDefine('PostAffiliate.Banner.delete', 'Pap_Db_Banner');
        $this->addDefine('PostAffiliate.BannersGrid.afterExecute', 'Gpf_Data_RecordSet');
        $this->addDefine('PostAffiliate.BannersGrid.buildWhere', 'Pap_Affiliates_Promo_SelectBuilderCompoundFilter');
        $this->addDefine('Pap_Affiliates_Promo_BannersGrid.modifyRecord', 'Gpf_Data_Record');
        $this->addDefine('PostAffiliate.Campaigns.getCampaignsForAffiliate', 'Gpf_Data_Record');
        $this->addDefine('PostAffiliate.RecognizeCommGroup.getCommissionGroup', 'Pap_Contexts_Tracking');
        $this->addDefine('PostAffiliate.BannerViewer.show', 'Pap_Tracking_BannerViewerRequest');
        $this->addDefine('PostAffiliate.BannerForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.BannerForm.afterAdd', 'Pap_Common_Banner');
        $this->addDefine('PostAffiliate.BannerForm.afterSave', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.BannerForm.afterChangeStatus', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.BannerForm.checkBeforeSave', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.BannerForm.afterCloneBanner', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.Banner.replaceBannerConstants', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.Banner.changeBannerImageUrl', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.RebrandPdfBanner_Variables.getAll', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.RebrandPdfBanner_Variables.getValue', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.BannerListbox.getBannerSelect', 'Gpf_SqlBuilder_SelectBuilder');
        $this->addDefine('PostAffiliate.Campaigns.getCampaignsSelect', 'Gpf_SqlBuilder_SelectBuilder');
        $this->addDefine('PostAffiliate.AffiliateRichListBox.createSelectBuilder', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.UserInCommissionGroup.addUser', 'Pap_Features_PrivateCampaigns_MailContext');
        $this->addDefine('PostAffiliate.UserInCommissionGroup.changeStatus', 'Pap_Features_PrivateCampaigns_MailContext');
        $this->addDefine('PostAffiliate.UserInCommissionGroup.deleteUser', 'Pap_Features_PrivateCampaigns_MailContext');
        $this->addDefine('PostAffiliate.CommissionGroupsForm.checkMoveUsersToDefaultGroup', 'Pap_Features_PrivateCampaigns_MailContext');
        $this->addDefine('PostAffiliate.CommissionGroupsForm.checkBeforeSave', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.AffiliateGeneralSettingsForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.AffiliateGeneralSettingsForm.save', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.AffiliateGeneralSettingsForm.loadGeneral', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.AffiliateGeneralSettingsForm.saveGeneral', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.click.beforeSaveVisitorAffiliate', 'Pap_Common_VisitorAffiliateCacheCompoundContext');
        $this->addDefine('PostAffiliate.click.isOverwriteEnabled', 'Pap_Contexts_Click');

        $this->addDefine('Tracker.saveCommissions.beforeSaveTransaction', 'Pap_Common_TransactionCompoundContext');
        $this->addDefine('Tracker.saveCommissions', 'Pap_Contexts_Tracking');
        $this->addDefine('Tracker.saveAllCommissions', 'Pap_Common_SaveCommissionCompoundContext');
        $this->addDefine('Tracker.saveCommissions.saveTransaction', 'Pap_Common_Transaction');

        $this->addDefine('Tracker.impression.afterSave', 'Pap_Contexts_Impression');

        $this->addDefine('Tracker.ComputeCommissions.computeCustomCommissions', 'Pap_Contexts_Action');
        $this->addDefine('Tracker.RecognizeAffiliate.getUserById', 'Gpf_Plugins_ValueContext');

        // $this->addDefine('Tracker.click.check', 'Pap_Contexts_Click'); // removed in newTracking
        $this->addDefine('Tracker.click.recognizeParameters', 'Pap_Contexts_Click');
        $this->addDefine('Tracker.click.beforeSaveClick', 'Pap_Contexts_Click');
        $this->addDefine('Tracker.click.afterSaveClick', 'Pap_Contexts_Click');
        $this->addDefine('Tracker.click.beforeSaveCommissions', 'Pap_Contexts_Click');
        $this->addDefine('Tracker.click.afterSaveCommissions', 'Pap_Contexts_Click');
        $this->addDefine('Tracker.click.fillClickParams', 'Pap_Db_ClickImpression');

        $this->addDefine('PostAffiliate.Pap_Tracking_ClickTracker.getClickUrl', 'Gpf_Plugins_ValueContext');

        $this->addDefine('Tracker.request.getCountryCode', 'Gpf_Data_Record');

        $this->addDefine('Tracker.action.recognizeParametersStarted', 'Pap_Common_VisitorAffiliateCacheCompoundContext');
        $this->addDefine('Tracker.action.recognizeParametersEnded', 'Pap_Common_VisitorAffiliateCacheCompoundContext');
        $this->addDefine('Tracker.action.recognizeAfterFraudProtection', 'Pap_Common_VisitorAffiliateCacheCompoundContext');
        $this->addDefine('Tracker.action.beforeSaveCommissions', 'Pap_Contexts_Action');
        $this->addDefine('Tracker.action.afterSaveCommissions', 'Pap_Contexts_Action');
        $this->addDefine('Tracker.action.computeTotalCost', 'Pap_Contexts_Action');
        $this->addDefine('Tracker.action.computeFixedCost', 'Pap_Contexts_Action');
        $this->addDefine('Tracker.action.computeCommission', 'Pap_Contexts_Action');
        $this->addDefine('Tracker.action.RecognizeAffiliate.getDefaultAffiliate', 'Pap_Contexts_Action');

        $this->addDefine('Tracker.action.saveCommissions', 'Pap_Common_ActionProcessorCompoundContext');

        $this->addDefine('FraudProtectionClicksForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('FraudProtectionClicksForm.save', 'Gpf_Rpc_Form');
        $this->addDefine('FraudProtectionSalesForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('FraudProtectionSalesForm.save', 'Gpf_Rpc_Form');
        $this->addDefine('FraudProtectionSignupsForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('FraudProtectionSignupsForm.save', 'Gpf_Rpc_Form');
        $this->addDefine('FraudProtectionLoginsForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('FraudProtectionLoginsForm.save', 'Gpf_Rpc_Form');

        $this->addDefine('FraudProtection.Action.check', 'Pap_Contexts_Action');
        $this->addDefine('FraudProtection.Click.check', 'Pap_Contexts_Click');
        $this->addDefine('FraudProtection.Signup.check', 'Pap_Signup_SignupFormContext');

        $this->addDefine('AccountFraudProtectionForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('AccountFraudProtectionForm.save', 'Gpf_Plugins_ValueContext');
        $this->addDefine('AccountFraudProtectionForm.Action.check', 'Pap_Contexts_Action');
        $this->addDefine('AccountFraudProtectionForm.Click.check', 'Pap_Contexts_Click');

        $this->addDefine('PostAffiliate.Transaction.afterSave', 'Pap_Common_Transaction');
        $this->addDefine('PostAffiliate.Transaction.beforeSave', 'Pap_Common_Transaction');
        $this->addDefine('PostAffiliate.Transaction.refundChargeback', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.Transaction.firstTimeApprove', 'Pap_Common_Transaction');

        $this->addDefine('PostAffiliate.TransactionForm.changeTransactionStatus', 'Pap_Common_Transaction');
        $this->addDefine('PostAffiliate.TransactionsForm.checkBeforeSave', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.TransactionsForm.afterSave', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.TransactionsForm.afterDelete', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.TransactionsForm.afterChangeStatus', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.TransactionsForm.afterLoadForm', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.TransactionsInfoData.transactionDetails', 'Gpf_Rpc_Data');

        $this->addDefine('PostAffiliate.TransactionsImportTask.loadTransaction', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.TransactionsImportForm.getColumnNames', 'Gpf_Data_IndexedRecordSet');

        $this->addDefine('PostAffiliate.CurrencyForm.save', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.CurrencyForm.load', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.ParameterNamesForm.save', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.AffiliateSignupForm.save', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.AffiliateSignupForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.AffiliateForm.fillAdd', 'Pap_Common_User');
        $this->addDefine('PostAffiliate.AffiliateForm.assignParent', 'Pap_Common_User');
        $this->addDefine('PostAffiliate.AffiliateForm.afterSave', 'Pap_Common_User');
        $this->addDefine('PostAffiliate.AffiliateForm.afterChangeStatusPerId', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.AffiliateForm.afterSavePayouts', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.UserForm.afterSave', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.LoggingForm.beforeSave', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.AccountSignupSettingsForm.save', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.AccountSignupSettingsForm.load', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.Invoice.delete', 'Pap_Db_Invoice');
        $this->addDefine('PostAffiliate.InvoiceForm.markaspaid', 'Gpf_DbEngine_RowBase');
        $this->addDefine('PostAffiliate.InvoiceForm.afterAdd', 'Pap_Db_Invoice');
        $this->addDefine('PostAffiliate.InvoiceForm.afterEdit', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.InvoiceForm.getNextInvoiceDateFrom', 'Gpf_DateTime');
        $this->addDefine('PostAffiliateNetwork.AccountsForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliateNetwork.AccountsForm.save', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliateNetwork.AccountsForm.afterSave', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliateNetwork.AccountsForm.afterChangeStatus', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliateNetwork.AccountsForm.afterDelete', 'Pap_Account');
        $this->addDefine('PostAffiliateNetwork.AccountSettingsForm.save', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.CampaignDetailsAdditionalForm.initFields', 'Pap_Merchants_Campaign_CampaignDetailsAdditionalForm');
        $this->addDefine('PostAffiliate.CampaignDetailsAdditionalForm.save', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.CampaignDetailsAdditionalForm.load', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.PayoutOption.getValue', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.PayoutOption.setValue', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.User.onInsert', 'Pap_Db_User');
        $this->addDefine('PostAffiliate.User.onUpdate', 'Pap_Db_User');
        $this->addDefine('PostAffiliate.User.beforeSave', 'Pap_Common_User');
        $this->addDefine('PostAffiliate.User.afterSave', 'Pap_Common_User');
        $this->addDefine('PostAffiliate.User.afterDelete', 'Pap_Common_User');
        $this->addDefine('PostAffiliate.User.beforeDelete', 'Pap_Common_User');
        $this->addDefine('PostAffiliate.User.afterInsert', 'Pap_Common_User');

        $this->addDefine('PostAffiliate.User.generatePrimaryKey', 'Pap_Db_User');

        $this->addDefine('PostAffiliate.CommissionType.beforeSaveCheck', 'Pap_Db_CommissionType');

        $this->addDefine('PostAffiliate.UserMail.initTemplateVariables', 'Gpf_Mail_Template');
        $this->addDefine('PostAffiliate.UserMail.setVariableValues', 'Pap_Mail_UserMail');

        $this->addDefine('PostAffiliate.EmailNotificationsForm.save', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.EmailNotificationsForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.EmailNotificationsForm.isMerchantEmailNotificationSettingName', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.Countries.getDefaultCountry', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.CommissionTypeEditAdditionalForm.initFields', 'Pap_Merchants_Campaign_CommissionTypeEditAdditionalForm');
        $this->addDefine('PostAffiliate.CommissionTypeEditAdditionalForm.save', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.CommissionTypeEditAdditionalForm.load', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.StatisticsBase.initDataTypes', 'Pap_Common_Reports_StatisticsBase');
        $this->addDefine('PostAffiliate.StatisticsBase.getDefaultDataType', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.StatisticsBase.getDefaultDataType2', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.Banner.replaceUrlConstants', 'Pap_Common_BannerReplaceVariablesContext');
        $this->addDefine('PostAffiliate.Banner.getDestinationUrl', 'Pap_Common_BannerDestinationCompound');

        $this->addDefine('PostAffiliate.Affiliates.Campaigns.initViewColumns', 'Pap_Merchants_Campaign_CampaignsGrid');
        $this->addDefine('PostAffiliate.Affiliates.Campaigns.initDefaultView', 'Pap_Merchants_Campaign_CampaignsGrid');
        $this->addDefine('PostAffiliate.Affiliates.Campaigns.buildWhere', 'Pap_Affiliates_Promo_SelectBuilderCompoundFilter');
        $this->addDefine('PostAffiliate.Affiliates.Campaigns.filterRow', 'Pap_Affiliates_Promo_RowCompoundFilter');
        $this->addDefine('PostAffiliate.Affiliates.Campaigns.initDataColumns', 'Pap_Affiliates_Promo_CampaignsGrid');
        $this->addDefine('PostAffiliate.Affiliates.Campaigns.buildSelect', 'Gpf_SqlBuilder_SelectBuilder');
        $this->addDefine('PostAffiliate.Affiliates.Campaigns.buildFrom', 'Gpf_SqlBuilder_SelectBuilder');
        $this->addDefine('PostAffiliate.Affiliates.Campaigns.buildGroupBy', 'Gpf_SqlBuilder_SelectBuilder');

        $this->addDefine('PostAffiliate.AffiliatePrivileges.initDefault', 'Pap_Privileges_Affiliate');

        $this->addDefine('PostAffiliate.Affiliates.Transactions.initDefaultView', 'Pap_Affiliates_Reports_TransactionsGrid');
        $this->addDefine('PostAffiliate.Affiliates.Transactions.initViewColumns', 'Pap_Affiliates_Reports_TransactionsGrid');
        $this->addDefine('PostAffiliate.Affiliates.Transactions.initDataColumns', 'Pap_Affiliates_Reports_TransactionsGrid');
        $this->addDefine('PostAffiliate.Affiliates.Transactions.modifyRecord', 'Gpf_Data_Record');

        $this->addDefine('PostAffiliate.AffiliateForm.setDefaultDbRowObjectValues', 'Pap_Affiliates_User');
        $this->addDefine('PostAffiliate.AffiliateForm.checkRefidIsValid', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.AffiliateForm.checkStatusBeforeSaveExtension', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.Stats.initTransactionTypes', 'Pap_Stats_TransactionTypeStats');

        $this->addDefine('PostAffiliate.AdminsGrid.initViewColumns', 'Pap_Features_MultipleMerchants_AdminsGrid');
        $this->addDefine('PostAffiliate.AdminsGrid.initDefaultView', 'Pap_Features_MultipleMerchants_AdminsGrid');
        $this->addDefine('PostAffiliate.Application.registerRolePrivileges', 'Pap_Application');
        $this->addDefine('PostAffiliate.ApplicationSettings.loadSetting', 'Pap_ApplicationSettings');
        $this->addDefine('PostAffiliate.Merchants.ApplicationSettings.loadSetting', 'Pap_ApplicationSettings');
        $this->addDefine('PostAffiliate.Merchants.ApplicationSettings.addAdditionalTrackingMethods', 'Gpf_Plugins_ValueContext');

        $this->addDefine('AffiliateNetwork.modifyWhere', 'Gpf_Common_SelectBuilderCompoundRecord');
        $this->addDefine('AffiliateNetwork.modifyWhereClause', 'Gpf_Common_WhereClauseCompoundRecord');
        $this->addDefine('AffiliateNetwork.modifyFrom', 'Gpf_Common_SelectBuilderCompoundRecord');
        $this->addDefine('TransactionsGridBase.modifyFrom', 'Gpf_Common_SelectBuilderCompoundRecord');

        $this->addDefine('AffiliateNetwork.directLinksModifyWhere', 'Gpf_SqlBuilder_SelectBuilder');
        $this->addDefine('AffiliateNetwork.rulesCampaignsGridModifyWhere', 'Gpf_SqlBuilder_SelectBuilder');

        $this->addDefine('Pap_Features_AffiliateNetwork_Signup_AccountSignupForm.checkBeforeSaveNotApi', 'Gpf_Rpc_Form');

        $this->addDefine('TransactionsGrid.initViewColumns', 'Pap_Common_Reports_TransactionsGridBase');
        $this->addDefine('TransactionsGrid.initDataColumns', 'Pap_Common_Reports_TransactionsGridBase');
        $this->addDefine('Pap_Common_User_DirectLinksGridBase.initViewColumns', 'Pap_Common_User_DirectLinksGridBase');
        $this->addDefine('Pap_Common_User_DirectLinksGridBase.initDataColumns', 'Pap_Common_User_DirectLinksGridBase');
        $this->addDefine('TransactionsGrid.buildFrom', 'Gpf_Common_SelectBuilderCompoundGridRecord');
        $this->addDefine('PostAffiliate.ClicksGrid.buildFrom', 'Gpf_Common_SelectBuilderCompoundGridRecord');
        $this->addDefine('TransactionsGrid.initSearchAffiliateCondition', 'Pap_Merchants_Transaction_TransactionsGrid');
        $this->addDefine('RecurringCommissionsGrid.initViewColumns', 'Pap_Common_Reports_TransactionsGridBase');
        $this->addDefine('RecurringCommissionsGrid.initDataColumns', 'Pap_Common_Reports_TransactionsGridBase');

        $this->addDefine('CampaignGrid.modifyWhere', 'Pap_Affiliates_Promo_SelectBuilderCompoundFilter');
        $this->addDefine('BannersGrid.modifyWhere', 'Pap_Affiliates_Promo_SelectBuilderCompoundFilter');
        $this->addDefine('ClicksGrid.modifyWhere', 'Pap_Affiliates_Promo_SelectBuilderCompoundFilter');
        $this->addDefine('MerchantCodesGrid.modifyWhere', 'Pap_Affiliates_Promo_SelectBuilderCompoundFilter');

        $this->addDefine('PostAffiliate.BannersGrid.initViewColumns', 'Gpf_View_GridService');
        $this->addDefine('PostAffiliate.BannersGrid.initDataColumns', 'Gpf_View_GridService');
        $this->addDefine('PostAffiliate.BannersGrid.initDefaultView', 'Gpf_View_GridService');

        $this->addDefine('PostAffiliate.VisitorAffiliatesGrid.initViewColumns', 'Gpf_View_GridService');
        $this->addDefine('PostAffiliate.VisitorAffiliatesGrid.initDataColumns', 'Gpf_View_GridService');
        $this->addDefine('PostAffiliate.VisitorAffiliatesGrid.initDefaultView', 'Gpf_View_GridService');

        $this->addDefine('PostAffiliate.ClicksGrid.initViewColumns', 'Pap_Merchants_Reports_ClicksGrid');
        $this->addDefine('PostAffiliate.ClicksGrid.initRawClicksSelect', 'Gpf_SqlBuilder_SelectBuilder');
        $this->addDefine('PostAffiliate.ClicksGrid.initDataColumns', 'Pap_Merchants_Reports_ClicksGrid');
        $this->addDefine('PostAffiliate.ClicksGrid.getCustomFilterFields', 'Gpf_View_CustomFilterFields');

        $this->addDefine('Pap_Affiliates_Reports_PeriodStats.fillDataToTemplate', 'Gpf_Templates_Template');

        $this->addDefine('PostAffiliate.Pap_Stats_Computer_Base.initSelectBuilder', 'Pap_Common_Reports_SelectBuilderCompoundParams');
        $this->addDefine('PostAffiliate.Pap_Stats_Computer_Transactions.initSelectClause', 'Gpf_SqlBuilder_SelectClause');
        $this->addDefine('PostAffiliate.Pap_Stats_Computer_Transactions.initGroupBy', 'Gpf_SqlBuilder_GroupByClause');
        $this->addDefine('PostAffiliate.Pap_Stats_Computer_Transactions.processResult', 'Gpf_SqlBuilder_SelectBuilder');
        $this->addDefine('PostAffiliate.Pap_Stats_Computer_TransactionsGrouped.initSelectClause', 'Gpf_SqlBuilder_SelectClause');
        $this->addDefine('PostAffiliate.Pap_Stats_Trans_SalesStatsProcessorTask.getGroupedTransactionsSelectWithoutAff', 'Gpf_SqlBuilder_SelectBuilder');

        $this->addDefine('Pap_Affiliate.assignTemplateVariables', 'Gpf_Templates_Template');
        $this->addDefine('PostAffiliate.AffiliatesGrid.createResultSelect', 'Gpf_Common_SelectBuilderCompoundRecord');
        $this->addDefine('PostAffiliate.AffiliatesGrid.initDataColumns', 'Pap_Merchants_User_AffiliatesGrid');
        $this->addDefine('PostAffiliate.AffiliatesGrid.getCustomFilterFields', 'Gpf_View_CustomFilterFields');
        $this->addDefine('PostAffiliate.TopAffiliatesGrid.createResultSelect', 'Gpf_Common_SelectBuilderCompoundRecord');
        $this->addDefine('PostAffiliate.PayAffiliatesGrid.createResultSelect', 'Gpf_Common_SelectBuilderCompoundRecord');
        $this->addDefine('PostAffiliate.PayAffiliatesGrid.checkFilterColumns', 'Pap_Merchants_Payout_PayAffiliatesGrid');
        $this->addDefine('PostAffiliate.PayAffiliatesGrid.getCustomFilterFields', 'Gpf_View_CustomFilterFields');
        $this->addDefine('PostAffiliate.PayAffiliatesGrid.addFilter', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.AffiliatesGridSimple.initDataColumns', 'Pap_Merchants_User_AffiliatesGridSimple');
        $this->addDefine('PostAffiliate.AffiliatesGridSimple.getCustomFilterFields', 'Gpf_View_CustomFilterFields');

        $this->addDefine('PostAffiliate.AffiliateLoginsGrid.initDataColumns', 'Pap_Merchants_User_AffiliateLoginsGrid');

        $this->addDefine('PostAffiliate.MassMailAffiliatesGrid.addFilter', 'Gpf_Common_SelectBuilderCompoundRecord');

        $this->addDefine('PostAffiliatePro.Pap_Mail_Reports_Report.setAccountId', 'Gpf_Data_Record');

        $this->addDefine('Tracker.ImpressionProcessor.getAllImpressions', 'Gpf_SqlBuilder_SelectBuilder');
        $this->addDefine('Tracker.ImpressionProcessor.updateProcessedImpressions', 'Gpf_SqlBuilder_UpdateBuilder');
        $this->addDefine('Tracker.ImpressionProcessor.createSubSelect', 'Gpf_SqlBuilder_SelectBuilder');
        $this->addDefine('PostAffiliate.Pap_Common_StatsGrid.initStatsColumns', 'Pap_Common_StatsColumnsContext');
        $this->addDefine('PostAffiliate.Pap_Common_StatsGrid.addStatCustomFilterFields', 'Gpf_View_CustomFilterFields');
        $this->addDefine('PostAffiliate.Pap_Common_StatsGrid.buildStatsFrom', 'Pap_Common_StatsGridParamsContext');
        $this->addDefine('TransactionsGrid.getCustomFilterFields', 'Gpf_View_CustomFilterFields');
        $this->addDefine('PostAffiliate.Affiliates.Transactions.getCustomFilterFields', 'Gpf_View_CustomFilterFields');
        $this->addDefine('PostAffiliate.Pap_Common_Reports_TransactionsGridBase.getCustomFilterFields', 'Gpf_View_CustomFilterFields');
        $this->addDefine('PostAffiliate.Pap_Common_Reports_TransactionsGridBase.addFilter', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.Pap_Common_StatsGrid.addAllActionsViewColumns', 'Pap_Common_StatsGrid');
        $this->addDefine('PostAffiliate.Pap_Common_StatsGrid.initAdditionalStatsParams', 'Pap_Common_Reports_FilterCompoundParams');
        $this->addDefine('PostAffiliate.Pap_Merchants_TopReferrerUrlStatsGrid.addAllActionsColumns', 'Gpf_View_GridService');

        $this->addDefine('Pap_Common_Campaign_CampaignForAffiliateRichListBox.getCampaignRecordSetForAffiliate', 'Pap_Affiliates_Promo_SelectBuilderCompoundFilter');
        $this->addDefine('Pap_Tracking_Action_ActionProcessor.processAccount', 'Pap_Contexts_Action');
        $this->addDefine('Pap_Tracking_Action_ActionProcessor.processCallBackUrl', 'Gpf_Plugins_ValueContext');
        $this->addDefine('Pap_Tracking_Action_RecognizeCampaign.forceChoosingProductId', 'Gpf_Plugins_ValueContext');
        $this->addDefine('Pap_Tracking_Common_RecognizeCampaign.onCampaignRecognized', 'Pap_Contexts_Tracking');
        $this->addDefine('Pap_Tracking_Action_RecognizeCampaign.getDefaultCampaign', 'Gpf_Plugins_ValueContext');
        $this->addDefine('Pap_Tracking_Action_RecognizeVisitorAffiliateFromIp.isTrackByIpEnabled', 'Gpf_Plugins_ValueContext');
        $this->addDefine('Pap_Tracking_Action_RecognizeVisitorAffiliateFromIp.getValidityInSeconds', 'Gpf_Plugins_ValueContext');
        $this->addDefine('Pap_Tracking_CallbackTracker.fillSignupParams', 'Gpf_Data_IndexedRecordSet');

        $this->addDefine('PostAffiliate.Pap_Merchants_Config_AffEmailNotificationsForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.Pap_Merchants_Config_AffEmailNotificationsForm.save', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.Pap_Affiliates_Profile_EmailNotificationsForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.Pap_Affiliates_Profile_EmailNotificationsForm.save', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.Pap_Affiliates_Profile_EmailNotificationsForm.isEmailNotificationSettingName', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.Pap_Account.onStatusChange', 'Pap_Account');

        $this->addDefine('PostAffiliate.OfflineSaleForm.createSale', 'Pap_Tracking_ActionObject');
        $this->addDefine('PostAffiliate.OfflineSaleForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.Pap_Db_Table_ClicksImpressions.getStatsSelect', 'Pap_Stats_StatsSelectContext');

        $this->addDefine('PostAffiliate.PapTrackingVisitProcessor.processVisit', 'Pap_Db_Visit');
        $this->addDefine('PostAffiliate.PapTrackingClickSaveClick.isClickUnique', 'Pap_Contexts_Click');
        $this->addDefine('PostAffiliate.Pap_Merchants_Payout_PayAffiliatesForm.payAffiliates', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.Pap_Merchants_Payout_PayAffiliatesForm.payAffiliatesProcessed', 'Gpf_Plugins_ValueContext');

        $this->addDefine('Pap_Stats_Computer_TransactionsStatsBuilder.buildGroupBy', 'Pap_Stats_Computer_TransactionsStatsBuilderContext');
        $this->addDefine('Pap_Stats_Computer_TransactionsStatsBuilder.buildWhere', 'Gpf_SqlBuilder_SelectBuilder');

        $this->addDefine('Pap_Common_Reports_DailyReportGrid.buildFrom', 'Gpf_Rpc_FilterCollection');

        $this->addDefine('Pap_Tracking_Action_SendTransactionNotificationEmails.sendOnNewSaleNotificationToMerchant', 'Gpf_Plugins_ValueContext');
        $this->addDefine('Pap_Tracking_Action_SendTransactionNotificationEmails.sendOnNewSaleNotificationToDirectAffiliate', 'Gpf_Plugins_ValueContext');
        $this->addDefine('Pap_Tracking_Action_SendTransactionNotificationEmails.sendOnNewSaleNotificationToParentAffiliate', 'Gpf_Plugins_ValueContext');
        $this->addDefine('Pap_Tracking_Action_SendTransactionNotificationEmails.sendOnChangeStatusNotificationToAffiliate', 'Gpf_Plugins_ValueContext');

        $this->addDefine('Pap_Db_Table_Campaigns.getCampaignsSelect', 'Gpf_SqlBuilder_SelectBuilder');
        $this->addDefine('Pap_Db_Table_Campaigns.createDefaultCommissionSettings', 'Pap_Common_Campaign');

        $this->addDefine('Pap_Mail_Reports_ReportsSendTask.generateNextPlanDate', 'Gpf_DateTime');

        $this->addDefine('PostAffiliate.IntegrationMethods.getIntegrationMethodsList', 'Gpf_Data_RecordSet');
        $this->addDefine('PostAffiliate.IntegrationMethods.getIntegrationStepsList', 'Gpf_Data_RecordSet');

        $this->addDefine('Pap_SignupBase.initFooterExtensions', 'Gpf_TemplateExtensionsContext');
        $this->addDefine('Pap_Affiliate.initFooterExtensions', 'Gpf_TemplateExtensionsContext');

        $this->addDefine('Pap_Signup_ContactUsForm.send', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.BannersGrid.getAvailibleBannerTypes', 'Gpf_Data_RecordSet');

        $this->addDefine('PostAffiliate.Features.ReCaptchaForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.Features.ReCaptchaForm.save', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.Pap_Merchants_Banner_BannersInfoData.loadFilteredStatistics', 'Gpf_Rpc_Data');

        $this->addDefine('PostAffiliate.AffiliateForm.getParentUserForReferralBonus', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.Pap_Db_UserInCommissionGroup.addUserToGroupAndSendNotification', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.UserInCommissionGroup.addUserToGroupWithoutNotification', 'Gpf_Plugins_ValueContext');
        $this->addDefine('Pap_Features_CommissionGroups_AffiliateGroupForm.addUserToGroup', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.Pap_Common_Condition.getAllConditions', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.Pap_Common_Condition.getClassName', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.Pap_Affiliates_Promo_DynamicLink.getDeeplinkCode', 'Gpf_Plugins_ValueContext');

        $this->addDefine('PostAffiliate.Pap_Db_Table_BannerDestinations.getDestinationUrl', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.Pap_Features_BannerDestinations_DestinationsGrid.initViewColumns', 'Gpf_View_GridService');
        $this->addDefine('PostAffiliate.Pap_Features_BannerDestinations_DestinationsGrid.initDataColumns', 'Gpf_View_GridService');
        $this->addDefine('PostAffiliate.Pap_Features_BannerDestinations_DestinationsGrid.initDefaultView', 'Gpf_View_GridService');
        $this->addDefine('PostAffiliate.BannerDestinations.recognizeDestinationUrl', 'Gpf_Plugins_ValueContext');

        //features extension points
        $this->addDefine('PostAffiliate.Features.PerformanceRewards.Action.createActionList', 'Pap_Features_PerformanceRewards_ActionList');
        $this->addDefine('Pap_Features_SplitCommissions_SplitCommissions.processVisitorAffiliates', 'Pap_Contexts_Action');
        $this->addDefine('Pap_Features_AffiliateTrackingCode_AffiliateCodesGrid.initViewColumns', 'Gpf_View_GridService');
        $this->addDefine('Pap_Features_SiteReplication_Replicator.replaceVariables', 'Pap_Features_SiteReplication_Replicator');
        $this->addDefine('Pap_Features_Common_AffiliateCampaignsGrid.initDefaultView', 'Pap_Features_Common_AffiliateCampaignsGrid');
        $this->addDefine('Pap_Features_Common_AffiliateGroupGrid.initDefaultView', 'Pap_Features_Common_AffiliateGroupGrid');
        $this->addDefine('Pap_Features_AffiliateNetwork_AccountsGrid.createResultSelect', 'Gpf_Common_SelectBuilderCompoundRecord');
        $this->addDefine('PostAffiliateNetwork.AccountsForm.checkBeforeSave', 'Gpf_Plugins_ValueContext');
        $this->addDefine('Pap_Features_MultipleMerchants_AdminsGrid.createResultSelect', 'Gpf_Common_SelectBuilderCompoundRecord');
        $this->addDefine('Pap_Features_MultipleMerchants_AdminForm.checkBeforeSave', 'Gpf_Plugins_ValueContext');
        $this->addDefine('Pap_Features_MultipleMerchants_AdminForm.load', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.Pap_Features_PerformanceRewards_RuleForm.checkBeforeFill', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.Pap_Features_PerformanceRewards_RuleForm.checkBeforeCopyDelete', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.Pap_Features_PerformanceRewards_Action_ChangeGroup.initTransactionSql', 'Gpf_Plugins_ValueContext');
        $this->addDefine('RecurringCommissions.beforeSaveRecurringCommissionEntry', 'Gpf_Plugins_ValueContext');
        $this->addDefine('Pap_Features_AuditLog_AuditLogGrid.initDataColumns', 'Pap_Features_AuditLog_AuditLogGrid');

        $this->addDefine('PostAffiliate.VisitsSalesLogsGrid.initDataColumns', 'Pap_Merchants_Tools_VisitsSalesLogsGrid');
        $this->addDefine('Pap_Merchants_Tools_VisitsSalesLogsForm.deleteRow', 'Gpf_Plugins_ValueContext');

        $this->addDefine('Pap_Mail_EmailSettingsForms.checkEmailAccount', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.Addons.changePlan', 'Gpf_Plugins_ValueContext');
        $this->addDefine('PostAffiliate.CookiesForm.load', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.TrackingForm.beforeSave', 'Gpf_Rpc_Form');
        $this->addDefine('PostAffiliate.TrackingForm.save', 'Gpf_Rpc_Form');

        $this->addDefine('PostAffiliate.UserTree.canInsertUserTreeUpdateTask', 'Gpf_Plugins_ValueContext');

        $this->addDefine('Pap_Features_AuditLog.initHandlers', 'Pap_Features_AuditLog_Handler_Factory');
        $this->addDefine('PostAffiliate.CommissionsInfoData.buildData', 'Gpf_Plugins_ValueContext');

        //TODO: move this to tests
        $this->addDefine('Pap_Tests_Mock_ExampleClass.testMethod', 'Pap_Tests_Mock_ExampleClass');
    }
}
